package com.demo

import org.springframework.test.context.DynamicPropertyRegistry
import org.springframework.test.context.DynamicPropertySource
import org.testcontainers.containers.localstack.LocalStackContainer
import org.testcontainers.containers.localstack.LocalStackContainer.Service.SQS
import org.testcontainers.junit.jupiter.Container
import org.testcontainers.utility.DockerImageName

class WithContainers {
    companion object {

        @JvmStatic
        @Container
        val localStackContainer: LocalStackContainer = LocalStackContainer(
            DockerImageName.parse("localstack/localstack:3.4.0")
        ).withServices(SQS)

        @JvmStatic
        @DynamicPropertySource
        fun localstackProperties(registry: DynamicPropertyRegistry) {
            println("Add properties with dynamic values to the Environment for integration tests!")
            println(localStackContainer.getEndpointOverride(SQS))
            println(localStackContainer.region)
            registry.add("cloud.aws.sqs.endpoint") { localStackContainer.getEndpointOverride(SQS) }
            registry.add("cloud.aws.region.static") { localStackContainer.region }
        }
    }
}
